=== modified file 'grackle-put-message'
--- grackle-put-message	2012-01-30 18:30:54 +0000
+++ grackle-put-message	2012-01-13 13:52:09 +0000
@@ -2,11 +2,9 @@
 import sys
 from grackle import client
 
-
 class UserError(Exception):
     """An error caused by a user mistake."""
 
-
 def main(*args):
     if len(args) != 2:
         raise UserError("Wrong number of arguments supplied.")

=== modified file 'grackle/client.py'
--- grackle/client.py	2012-01-30 18:28:17 +0000
+++ grackle/client.py	2012-01-13 14:30:09 +0000
@@ -8,28 +8,17 @@
 
 
 class UnsupportedOrder(Exception):
-    """Raised when an Unsupported order is requested."""
+    pass
 
 
 class GrackleClient:
-    """Class for accessing Grackle web service."""
 
     def __init__(self, host, port):
-        """Constructor.
-
-        :param host: The name of the server.
-        :param port: The port providing Grackle service.
-        """
         self.host = host
         self.port = port
         self.netloc = '%s:%d' % (host, port)
 
     def archive_url(self, archive_id, query):
-        """Return the URL for an archive
-
-        :param archive_id: The id of the archive to generate the URL for.
-        :param query: The query to use in the URL, as a dict.
-        """
         path = '/archive/%s' % quote(archive_id)
         query_string = urlencode(query)
         return urlunparse(('http', self.netloc, path, '', query_string, ''))
@@ -37,24 +26,16 @@
     def _get_connection(self):
         return httplib.HTTPConnection(self.host, self.port)
 
-    def _method_archive(self, method, archive_id, query, body=None):
-        """Perform an HTTP method on an archive's URL."""
+    def _verb_archive(self, verb, archive_id, query, body=None):
         url = self.archive_url(archive_id, query)
         connection = self._get_connection()
-        connection.request(method, url, body)
+        connection.request(verb, url, body)
         return connection.getresponse()
 
     def put_message(self, archive_id, key, file_obj):
-        """Put a message into an archive.
-
-        :param archive_id: The archive to put the message into.
-        :param key: An arbitrary identifier that can later be used to retrieve
-            the message.
-        :param file_obj: The raw text of the message, as a file.
-        """
-        response = self._method_archive(
+        response = self._verb_archive(
             'POST', archive_id, {'key': key}, file_obj.read())
-        response.read()
+        data = response.read()
         if response.status == httplib.BAD_REQUEST:
             raise Exception('wtf')
         elif response.status == httplib.CREATED:
@@ -63,31 +44,7 @@
             raise Exception('!!')
 
     def get_messages(self, archive_id, message_ids=None, limit=None,
-                     memo=None, order=None, headers=None,
-                     max_body_length=None, include_hidden=False):
-        """Retrieve specified messages.
-
-        :param archive_id: The archive to retrieve messages from.
-        :param message_ids: (optional) Retrieve only messages with these ids.
-        :param limit: The maximum number of messages to return.  The server
-            may, at its discretion, return fewer.
-        :param memo: (optional) Opaque identifier describing the position in
-            the list of messages to return.  The combination of a memo and a
-            limit describes a batch of results.  If not specified, the start
-            is used.
-        :param order: The order to return results in.  Supported orders are
-            determined by the server.  See test_client.SUPPORTED_ORDERS for an
-            example.
-        :param headers: The headers to include in the message.  Only headers
-            actually present in the message will be provided.  If unspecified,
-            most headers will be included.
-        :param max_body_length: The maximum length for a message's body.  When
-            multiple messages are nested (as with a thread), this applies to
-            each message's body, not the aggregate length of all messages'
-            bodies.
-        :param include_hidden: If true, include messages that have been
-            flagged "hidden" in the results.
-        """
+                     memo=None, order=None, headers=None):
         parameters = {}
         if message_ids is not None:
             parameters['message_ids'] = message_ids
@@ -99,12 +56,10 @@
             parameters['order'] = order
         if headers is not None:
             parameters['headers'] = headers
-        if max_body_length is not None:
-            parameters['max_body_length'] = max_body_length
-        parameters['include_hidden'] = include_hidden
         query = {'parameters': simplejson.dumps(parameters)}
-        response = self._method_archive('GET', archive_id, query)
+        response = self._verb_archive('GET', archive_id, query)
         if response.status == httplib.BAD_REQUEST:
             raise UnsupportedOrder
         data = response.read()
         return simplejson.loads(data)
+

=== modified file 'grackle/tests/test_client.py'
--- grackle/tests/test_client.py	2012-01-30 18:44:20 +0000
+++ grackle/tests/test_client.py	2012-01-13 14:30:09 +0000
@@ -3,12 +3,10 @@
     BaseHTTPRequestHandler,
     )
 import httplib
-import logging
 import os
 from signal import SIGKILL
 import simplejson
 from StringIO import StringIO
-import sys
 from unittest import TestCase
 from urlparse import urlparse
 from urlparse import parse_qs
@@ -36,128 +34,18 @@
     return threads.values()
 
 
-class GrackleStore:
-    """A memory-backed message store."""
-
-    def __init__(self, messages):
-        """Constructor."""
-        self.messages = messages
-
-    def get_messages(self, archive_id, query_string):
-        """Return matching messages.
-
-        :param archive_id: The archive to retrieve from.
-        :param query_string: Contains 'parameters', which is a JSON-format
-            string describing parameters.
-        """
-        query = parse_qs(query_string)
-        parameters = simplejson.loads(query['parameters'][0])
-        order = parameters.get('order')
-        messages = self.messages[archive_id]
-        if order is not None:
-            if order not in SUPPORTED_ORDERS:
-                raise UnsupportedOrder
-            elif order.startswith('thread_'):
-                threaded = threaded_messages(messages)
-                messages = []
-                if order == 'thread_subject':
-                    threaded.sort(key=lambda t: t[0]['subject'])
-                if order == 'thread_oldest':
-                    threaded.sort(key=lambda t: min(m['date'] for m in t))
-                if order == 'thread_newest':
-                    threaded.sort(key=lambda t: max(m['date'] for m in t))
-                for thread in threaded:
-                    messages.extend(thread)
-            else:
-                messages.sort(key=lambda m: m[order])
-        new_messages = []
-        for message in messages:
-            if (not parameters['include_hidden']
-                and message.get('hidden', False)):
-                continue
-
-            if ('message_ids' in parameters
-                and message['message_id'] not in parameters['message_ids']):
-                continue
-            message = dict(message)
-            if 'headers' in parameters:
-                headers = dict(
-                    (k, v) for k, v in message['headers'].iteritems()
-                    if k in parameters['headers'])
-                message['headers'] = headers
-            max_body = parameters.get('max_body_length')
-            if max_body is not None:
-                message['body'] = message['body'][:max_body]
-            new_messages.append(message)
-        messages = new_messages
-        limit = parameters.get('limit', 100)
-        memo = parameters.get('memo')
-        message_id_indices = dict(
-            (m['message_id'], idx) for idx, m in enumerate(messages))
-        if memo is None:
-            start = 0
-        else:
-            start = message_id_indices[memo.encode('rot13')]
-        if start > 0:
-            previous_memo = messages[start - 1]['message_id'].encode('rot13')
-        else:
-            previous_memo = None
-        end = min(start + limit, len(messages))
-        if end < len(messages):
-            next_memo = messages[end]['message_id'].encode('rot13')
-        else:
-            next_memo = None
-        messages = messages[start:end]
-
-        response = {
-            'messages': messages,
-            'next_memo': next_memo,
-            'previous_memo': previous_memo
-            }
-        return response
-
-
-class ForkedFakeService:
-    """A Grackle service fake, as a ContextManager."""
-
-    def __init__(self, port, messages=None, write_logs=False):
-        """Constructor.
-
-        :param port: The tcp port to use.
-        :param messages: A dict of lists of dicts representing messages.  The
-            outer dict represents the archive, the list represents the list of
-            messages for that archive.
-        :param write_logs: If true, log messages will be written to stdout.
-        """
+class ForkedFake:
+
+    def __init__(self, port, messages=None):
         self.pid = None
         self.port = port
-        if messages is None:
-            self.messages = {}
-        else:
-            self.messages = messages
+        self.messages = messages
         self.read_end, self.write_end = os.pipe()
-        self.write_logs = write_logs
-
-    @staticmethod
-    def from_client(client, messages=None):
-        """Instantiate a ForkedFakeService from the client.
-
-        :param port: The client to provide service for.
-        :param messages: A dict of lists of dicts representing messages.  The
-            outer dict represents the archive, the list represents the list of
-            messages for that archive.
-        """
-        return ForkedFakeService(client.port, messages)
 
     def is_ready(self):
-        """Tell the parent process that the server is ready for writes."""
         os.write(self.write_end, 'asdf')
 
     def __enter__(self):
-        """Run the service.
-
-        Fork and start a server in the child.  Return when the server is ready
-        for use."""
         pid = os.fork()
         if pid == 0:
             self.start_server()
@@ -166,16 +54,12 @@
         return
 
     def start_server(self):
-        """Start the HTTP server."""
         service = HTTPServer(('', self.port), FakeGrackleRequestHandler)
-        service.store = GrackleStore(self.messages)
-        for archive_id, messages in service.store.messages.iteritems():
+        service.messages = self.messages
+        for archive_id, messages in service.messages.iteritems():
             for message in messages:
                 message.setdefault('headers', {})
         self.is_ready()
-        if self.write_logs:
-            logging.basicConfig(
-                stream=sys.stderr, level=logging.INFO)
         service.serve_forever()
 
     def __exit__(self, exc_type, exc_val, traceback):
@@ -188,15 +72,8 @@
 
 
 class FakeGrackleRequestHandler(BaseHTTPRequestHandler):
-    """A request handler that forwards to server.store."""
-
-    def __init__(self, *args, **kwargs):
-        """Constructor.  Sets up logging."""
-        self.logger = logging.getLogger('http')
-        BaseHTTPRequestHandler.__init__(self, *args, **kwargs)
 
     def do_POST(self):
-        """Create a message on POST."""
         message = self.rfile.read(int(self.headers['content-length']))
         if message == 'This is a message':
             self.send_response(httplib.CREATED)
@@ -206,34 +83,86 @@
             self.send_error(httplib.BAD_REQUEST)
 
     def do_GET(self):
-        """Retrieve a list of messages on GET."""
         scheme, netloc, path, params, query_string, fragments = (
             urlparse(self.path))
         parts = path.split('/')
         if parts[1] == 'archive':
-            try:
-                response = self.server.store.get_messages(
-                    parts[2], query_string)
-                self.send_response(httplib.OK)
-                self.end_headers()
-                self.wfile.write(simplejson.dumps(response))
-            except UnsupportedOrder:
+            self.get_messages(parts[2], query_string)
+
+    def get_messages(self, archive_id, query_string):
+        query = parse_qs(query_string)
+        parameters = simplejson.loads(query['parameters'][0])
+        order = parameters.get('order')
+        messages = self.server.messages[archive_id]
+        if order is not None :
+            if order not in SUPPORTED_ORDERS:
                 self.send_response(httplib.BAD_REQUEST)
                 self.wfile.write('Unsupported order')
                 return
-
-    def log_message(self, format, *args):
-        """Override log_message to use standard Python logging."""
-        message = "%s - - [%s] %s\n" % (
-            self.address_string(), self.log_date_time_string(), format % args)
-        self.logger.info(message)
+            elif order.startswith('thread_'):
+                threaded = threaded_messages(messages)
+                messages = []
+                if order == 'thread_subject':
+                    threaded.sort(key=lambda t: t[0]['subject'])
+                if order == 'thread_oldest':
+                    threaded.sort(key=lambda t: min(m['date'] for m in t))
+                if order == 'thread_newest':
+                    threaded.sort(key=lambda t: max(m['date'] for m in t))
+                for thread in threaded:
+                    messages.extend(thread)
+            else:
+                messages.sort(key=lambda m: m[order])
+        messages = [m for m in messages
+                    if 'message_ids' not in parameters or
+                    m['message_id'] in parameters['message_ids']]
+        self.send_response(httplib.OK)
+        self.end_headers()
+        limit = parameters.get('limit', 100)
+        memo = parameters.get('memo')
+        message_id_indices = dict(
+            (m['message_id'], idx) for idx, m in enumerate(messages))
+        if memo is None:
+            start = 0
+        else:
+            start = message_id_indices[memo.encode('rot13')]
+        if start > 0:
+            previous_memo = messages[start - 1]['message_id'].encode('rot13')
+        else:
+            previous_memo = None
+        end = min(start + limit, len(messages))
+        if end < len(messages):
+            next_memo = messages[end]['message_id'].encode('rot13')
+        else:
+            next_memo = None
+        messages = messages[start:end]
+        new_messages = []
+        for message in messages:
+            message = dict(message)
+            if 'headers' in parameters:
+                headers = dict(
+                    (k, v) for k, v in message['headers'].iteritems()
+                    if k in parameters['headers'])
+                message['headers'] = headers
+            new_messages.append(message)
+        response = {
+            'messages': new_messages,
+            'next_memo': next_memo,
+            'previous_memo': previous_memo
+            }
+        self.wfile.write(simplejson.dumps(response))
+
+
+def fake_grackle_service(client, messages=None):
+    if messages is None:
+        messages = {}
+    return ForkedFake(client.port, messages)
 
 
 class TestPutMessage(TestCase):
 
     def test_put_message(self):
         client = GrackleClient('localhost', 8436)
-        with ForkedFakeService.from_client(client):
+        with fake_grackle_service(client):
             client.put_message('arch1', 'asdf', StringIO('This is a message'))
             with ExpectedException(Exception, 'wtf'):
                 client.put_message('arch1', 'asdf',
@@ -247,11 +176,11 @@
 
     def assertMessageIDs(self, ids, messages):
         self.assertIDOrder(
-            sorted(ids), sorted(messages, key=lambda m: m['message_id']))
+            sorted(ids), sorted(messages, key=lambda m:m['message_id']))
 
     def test_get_messages(self):
         client = GrackleClient('localhost', 8435)
-        with ForkedFakeService.from_client(client,
+        with fake_grackle_service(client,
             {'baz':
             [{'message_id': 'foo'},
              {'message_id': 'bar'}]}):
@@ -263,7 +192,7 @@
 
     def test_get_messages_by_id(self):
         client = GrackleClient('localhost', 8437)
-        with ForkedFakeService.from_client(client,
+        with fake_grackle_service(client,
             {'baz':
             [{'message_id': 'foo'},
              {'message_id': 'bar'}]}):
@@ -273,7 +202,7 @@
 
     def test_get_messages_batching(self):
         client = GrackleClient('localhost', 8438)
-        with ForkedFakeService.from_client(client,
+        with fake_grackle_service(client,
             {'baz':
             [{'message_id': 'foo'},
              {'message_id': 'bar'}]}):
@@ -288,7 +217,7 @@
 
     def get_messages_member_order_test(self, key):
         client = GrackleClient('localhost', 8439)
-        with ForkedFakeService.from_client(client,
+        with fake_grackle_service(client,
                 {'baz': [{'message_id': 'foo', key: '2011-03-25'},
                  {'message_id': 'bar', key: '2011-03-24'}]}):
             response = client.get_messages('baz')
@@ -307,7 +236,7 @@
 
     def test_get_messages_thread_subject_order(self):
         client = GrackleClient('localhost', 8439)
-        with ForkedFakeService.from_client(client, {'baz': [
+        with fake_grackle_service(client, {'baz': [
             {'message_id': 'bar', 'subject': 'y'},
             {'message_id': 'qux', 'subject': 'z'},
             {'message_id': 'foo', 'subject': 'x', 'in_reply_to': 'qux'},
@@ -321,7 +250,7 @@
 
     def test_get_messages_thread_oldest_order(self):
         client = GrackleClient('localhost', 8439)
-        with ForkedFakeService.from_client(client, {'baz': [
+        with fake_grackle_service(client, {'baz': [
             {'message_id': 'bar', 'date': 'x'},
             {'message_id': 'qux', 'date': 'z'},
             {'message_id': 'foo', 'date': 'y', 'in_reply_to': 'qux'},
@@ -335,7 +264,7 @@
 
     def test_get_messages_thread_newest_order(self):
         client = GrackleClient('localhost', 8439)
-        with ForkedFakeService.from_client(client, {'baz': [
+        with fake_grackle_service(client, {'baz': [
             {'message_id': 'bar', 'date': 'x'},
             {'message_id': 'qux', 'date': 'w'},
             {'message_id': 'foo', 'date': 'y', 'in_reply_to': 'bar'},
@@ -350,15 +279,15 @@
 
     def test_get_messages_unsupported_order(self):
         client = GrackleClient('localhost', 8439)
-        with ForkedFakeService.from_client(client,
+        with fake_grackle_service(client,
                 {'baz': [{'message_id': 'foo', 'date': '2011-03-25'},
                  {'message_id': 'bar', 'date': '2011-03-24'}]}):
-            with ExpectedException(UnsupportedOrder, ''):
+            with ExpectedException(UnsupportedOrder):
                 client.get_messages('baz', order='nonsense')
 
     def test_get_messages_headers_no_headers(self):
         client = GrackleClient('localhost', 8440)
-        with ForkedFakeService.from_client(client,
+        with fake_grackle_service(client,
             {'baz': [
                 {'message_id': 'foo'}
             ]}):
@@ -369,8 +298,8 @@
         self.assertEqual({}, first_message['headers'])
 
     def test_get_messages_headers_exclude_headers(self):
-        client = GrackleClient('localhost', 8441)
-        with ForkedFakeService.from_client(client,
+        client = GrackleClient('localhost', 8440)
+        with fake_grackle_service(client,
             {'baz': [
                 {'message_id': 'foo', 'headers': {'From': 'me'}}
             ]}):
@@ -381,8 +310,8 @@
         self.assertEqual({}, first_message['headers'])
 
     def test_get_messages_headers_include_headers(self):
-        client = GrackleClient('localhost', 8442)
-        with ForkedFakeService.from_client(client,
+        client = GrackleClient('localhost', 8440)
+        with fake_grackle_service(client,
             {'baz': [
                 {'message_id': 'foo', 'headers': {'From': 'me', 'To': 'you'}}
             ]}):
@@ -391,25 +320,3 @@
         first_message = response['messages'][0]
         self.assertEqual('foo', first_message['message_id'])
         self.assertEqual({'From': 'me', 'To': 'you'}, first_message['headers'])
-
-    def test_get_messages_max_body_length(self):
-        client = GrackleClient('localhost', 8443)
-        with ForkedFakeService.from_client(client,
-            {'baz': [
-                {'message_id': 'foo', 'body': u'abcdefghi'}
-            ]}):
-            response = client.get_messages('baz', max_body_length=3)
-        first_message = response['messages'][0]
-        self.assertEqual('abc', first_message['body'])
-
-    def test_include_hidden(self):
-        client = GrackleClient('localhost', 8444)
-        with ForkedFakeService.from_client(client,
-            {'baz': [
-                {'message_id': 'foo', 'hidden': True},
-                {'message_id': 'bar', 'hidden': False}
-            ]}):
-            response = client.get_messages('baz', include_hidden=True)
-            self.assertMessageIDs(['bar', 'foo'], response['messages'])
-            response = client.get_messages('baz', include_hidden=False)
-            self.assertMessageIDs(['bar'], response['messages'])

